﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MyFirstPictureGallery
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();

            vScrollBar1.Maximum = 0;
            hScrollBar1.Maximum = 0;

            pictureBox1.Paint += (sender, e) =>
                {
                    if (listBox1.SelectedItem == null)
                    {
                        return;
                    }

                    (listBox1.SelectedItem as IPicture)
                        .Draw(e.Graphics, hScrollBar1.Value, vScrollBar1.Value);
                };
        }

        private void quitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();

            //Environment.Exit(0);
        }

        private void squareToolStripMenuItem_Click(object sender, EventArgs e)
        {
            listBox1.Items.Add(new Square(Color.Red));
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            //for (int i = 0; i < listBox1.Items.Count; i++)
            //{
            //    pictureBox1.Paint -= (listBox1.Items[i] as IPicture).Draw;
            //}

            //foreach (object item in listBox1.Items)
            //{
            //    pictureBox1.Paint -= (item as IPicture).Draw;
            //}

            //pictureBox1.Paint += (listBox1.SelectedItem as IPicture).Draw;

            IPicture picture = (listBox1.SelectedItem as IPicture);

            hScrollBar1.Maximum = Math.Max(0, (picture.Size.Width - pictureBox1.Width));
            vScrollBar1.Maximum = Math.Max(0, (picture.Size.Height - pictureBox1.Height));

            pictureBox1.Invalidate();
        }

        private void circleToolStripMenuItem_Click(object sender, EventArgs e)
        {
            listBox1.Items.Add(new Circle(Color.Blue));
        }

        private void triangleToolStripMenuItem_Click(object sender, EventArgs e)
        {
            listBox1.Items.Add(new Triangle(Color.Green));
        }

        private void pictureToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog openDiag = new OpenFileDialog();

            openDiag.Filter = "Image Files (*.png, *.bmp, *.jpg)|*.png;*.bmp;*.jpg";
            openDiag.Title = "Choose picture to open";

            if (openDiag.ShowDialog() == DialogResult.OK)
            {
                listBox1.Items.Add(new Picture(openDiag.FileName));
            }
        }

        private void vScrollBar1_Scroll(object sender, ScrollEventArgs e)
        {
            pictureBox1.Invalidate();
        }
        
        private void hScrollBar1_Scroll(object sender, ScrollEventArgs e)
        {
            pictureBox1.Invalidate();
        }
    }
}
