﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MyFirstPictureGallery
{
    class Picture : IPicture
    {
        private Image image;

        public Size Size
        {
            get
            {
                return new Size((image.Size.Width + 10), (image.Size.Height + 10));
            }
        }

        public Picture(string filePath)
        {
            image = Image.FromFile(filePath);
        }

        public void Draw(Graphics g, int x, int y)
        {
            g.DrawImage(image,
                new Rectangle((5 - x), (5 - y), image.Size.Width, image.Size.Height));
        }

        public override string ToString()
        {
            return "Custom Picture";
        }
    }
}
